#INCLUDE "dcdialog.CH"
#INCLUDE "appevent.CH"

#DEFINE EVENT_DATABASE_TOP        xbeP_User + 1
#DEFINE EVENT_DATABASE_PREVIOUS   xbeP_User + 2
#DEFINE EVENT_DATABASE_NEXT       xbeP_User + 3
#DEFINE EVENT_DATABASE_BOTTOM     xbeP_User + 4

FUNCTION Main()

LOCAL GetList[0], oMenuBar, oSubMenu, oDlg, oStatTop, GetOptions, oToolbar

DC_LoadRdds()

DCSTATUSBAR oStatTop ALIGN DCGUI_ALIGN_TOP HEIGHT 24

@ 0,0 DCTOOLBAR oToolBar PARENT oStatTop SIZE 400,24 PIXEL BUTTONSIZE 100,24 TYPE XBPSTATIC_TYPE_TEXT

DCADDBUTTONXP CAPTION '~Top' PARENT oToolBar ACTION {||PostAppEvent(EVENT_DATABASE_TOP,,,SetDisplayFocus())}
DCADDBUTTONXP CAPTION '~Previous' PARENT oToolBar ACTION {||PostAppEvent(EVENT_DATABASE_PREVIOUS,,,SetDisplayFocus())}
DCADDBUTTONXP CAPTION '~Next' PARENT oToolBar ACTION {||PostAppEvent(EVENT_DATABASE_NEXT,,,SetDisplayFocus())}
DCADDBUTTONXP CAPTION '~Bottom' PARENT oToolBar ACTION {||PostAppEvent(EVENT_DATABASE_BOTTOM,,,SetDisplayFocus())}

DCMENUBAR oMenuBar

DCSUBMENU oSubMenu PROMPT 'File' PARENT oMenuBar

DCMENUITEM 'Browse Xtest' PARENT oSubMenu ;
   ACTION {|o|o := Thread():new(), Sleep(5), o:start({||BrowseXtest(oDlg)})}

DCGETOPTIONS WINDOWWIDTH 800 WINDOWHEIGHT 600

DCREAD GUI TITLE 'Test Program' OPTIONS GetOptions PARENT @oDlg

RETURN nil

* -----------

PROC Appsys ; RETURN

* -----------

FUNCTION SetDisplayFocus( oDlg )

STATIC soDlg

IF Valtype(oDlg) == 'O'
  soDlg := oDlg
ENDIF

RETURN soDlg

* -----------

FUNCTION BrowseXTest( oMainDlg )

LOCAL GetList[0], oBrowse, oDlg

USE XTest INDEX XTest VIA 'DBFCDX'

DCUSEREVENT EVENT_DATABASE_TOP ACTION {||Xtest->(dbGoTop()),oBrowse:refreshAll()}
DCUSEREVENT EVENT_DATABASE_PREVIOUS ACTION {||Xtest->(dbSkip(-1)),oBrowse:refreshAll()}
DCUSEREVENT EVENT_DATABASE_NEXT ACTION {||Xtest->(dbSkip()),oBrowse:refreshAll()}
DCUSEREVENT EVENT_DATABASE_BOTTOM ACTION {||Xtest->(dbGoBottom()),oBrowse:refreshAll()}

@ 0,0 DCBROWSE oBrowse ALIAS 'Xtest' SIZE 80,20

DCBROWSECOL FIELD Xtest->areacode HEADER 'Area' WIDTH 4 PARENT oBrowse
DCBROWSECOL FIELD Xtest->exchange HEADER 'Exchange' WIDTH 4 PARENT oBrowse
DCBROWSECOL FIELD Xtest->number HEADER 'Number' WIDTH 4 PARENT oBrowse

DCREAD GUI FIT TITLE 'Browsing XTest' APPWINDOW oMainDlg:drawingArea ;
   EVAL {|o|oDlg := o, o:setDisplayFocus := {||(wtf oDlg),SetDisplayFocus(oDlg)}, SetDisplayFocus(oDlg)}

RETURN nil


